package org.xbib.j2html.tags;

import org.junit.jupiter.api.Test;
import org.xbib.j2html.rendering.FlatHtml;
import org.xbib.j2html.rendering.IndentedHtml;

import java.io.IOException;

import static org.xbib.j2html.TagCreator.rawHtml;
import static org.xbib.j2html.TagCreator.text;
import static org.hamcrest.MatcherAssert.assertThat;
import static org.hamcrest.Matchers.is;

public class TextTest {

    @Test
    public void null_text_is_rendered_as_a_string_literal() throws IOException {
        assertThat(text(null).render(FlatHtml.inMemory()).toString(), is("null"));
        assertThat(text(null).render(IndentedHtml.inMemory()).toString(), is("null\n"));
    }

    @Test
    public void null_unescaped_text_is_rendered_as_a_string_literal() throws IOException {
        assertThat(rawHtml(null).render(FlatHtml.inMemory()).toString(), is("null"));
        assertThat(rawHtml(null).render(IndentedHtml.inMemory()).toString(), is("null\n"));
    }
}
